package week01

import scala.annotation.tailrec

object Gyakorlat extends App {
  def xnegyzet( x : Double ) : Double = x*x
  def ketxkob( x : Double ) : Double = 2*x*x*x
  def masodfoku(  a : Double, b : Double, c : Double, x : Double ) : Double = a*x*x + b*x + c

  def ackermann( n : Int, m : Int ) : Int = {
    if( n == 0 ) m+1
    else if( m == 0) ackermann( n-1, 1 )
    else ackermann( n-1, ackermann( n, m - 1))
  }

  def myNeg( x : Boolean ) : Boolean = if( x ) false else true
  def myAnd( x : Boolean, y : => Boolean ) : Boolean = if(x) y else false
  def myOr( x : Boolean, y : => Boolean ) : Boolean = if(x) true else y

  def addCurry( c : Double ) : Double => Double = { x  => x+c }
  def createMasodfoku( a : Double, b : Double, c : Double ) : Double => Double =
  {
    x => a * x * x + b * x + c
  }

  def fakt( n : Int ) : Int = {
    @tailrec
    def fakt( n : Int, acc : Int ) : Int = if( n <= 1 ) acc else fakt( n-1 , acc * n )
    fakt( n, 1 )
  }

}
