package week08

import java.io.{BufferedReader, InputStreamReader}
import java.net.URL

object Gyakorlat {
  val url = new URL("http://www.inf.u-szeged.hu/~szabivan/download/scala/words.txt")

  /**
   * Olvassuk be egy Vector[String]-be az in BufferedReader szöveges forrás sorai közül a nemüreseket
   * lowercaselve!
   * ehhez metódusok:
   * in.readLine() -- beolvassa a következő sort. Ha nincs több, akkor nullt ad, egyébként a sort mint String-et.
   */
  def readContents(in: BufferedReader): Vector[String] = ???

  /**
   * Inicializáljuk a szavaink listáját:
   * - nyitjuk az URL-t, készítünk belőle InputStreamReadert, abból BufferedReadert,
   * - felolvassuk a sorait a vektorba --> csak ezt kell implementáljuk
   * - bezárjuk a readert
   * - visszaadjuk a stringvektort.
   * (Normális, Java filekezelésért, elvárható hibakezeléssel lásd majd a progegy gyakanyagot.)
   */
  val allWords: Vector[String] = {
    val in = new BufferedReader(new InputStreamReader(url.openStream()))
    val ret = readContents(in)
    in.close()
    ret
  }
  /**
   * A warm-up task: az inputként kapott s string összes *egyszavas* anagrammáját,
   * ami az allWords listában szerepel, készítsük el!
   * Az eredményt pakoljuk bele a Java oldalról kapott list-be.
   */
  def oneWordAnagrams(s: String, list: java.util.List[String]): Unit = ???

  /**
   * Készítsünk el egy (String,String) listát, amiben az allWords-beli összes anagramma-pár szerepel!
   * Mondjuk a pár első komponense legyen az ábécé szerinti kisebb szó.
   * sanity check: 93 ilyen pár kéne legyen az outputban.
   */
  def anagramsInAllWords(list: java.util.List[String]): Unit = ???

  /**
   * A main task: az inputként kapott s string összes anagrammáját, ami előáll
   * az allWords lista szavaiból, mindegyiket csak egyszer, készítsük el!
   * Az eredményt pakoljuk bele a Java oldalról kapott list-be.
   */
  def anagrams(s: String, list: java.util.List[String]): Unit = ???
}
